import java.util.*;
import java.net.*;
import java.io.*;
import javazoom.jl.player.advanced.*;
import javazoom.jl.player.*;
import javazoom.jl.decoder.*;


class Player extends Thread
{
      public static final int PLAYING=1,STOPPED=2,PAUSED=3;
      
      List toplay;
      List history;

      boolean done = false;
      String nowPlaying = null;

      private int state = PLAYING;

      PlayMusicD deamon;

      TweakedPlayer aplayer = null;
   
      public Player(List toplay, List history, PlayMusicD deamon)
      {
	 this.toplay = toplay;
	 this.history = history;
	 this.deamon = deamon;
      }

      public void run()
      {
	 while (true)
	 {
	    if(aplayer == null && !stopped())
	       startPlayingSong();
	    Utility.sleep(300);
	 }
      }

      public boolean stopped()
      {
	 return state == STOPPED;
      }

      public boolean paused()
      {
	 return state == PAUSED;
      }

      public boolean playing()
      {
	 return state == PLAYING;
      }


      public String setUpNextSong()
      {
	 return setUpNextSong(1);
      }

      public String setUpNextSong(int n)
      {	 
	 for (int i = 0 ; i < n ; i++)
	 {
	    if(nowPlaying != null)
	    {
	       history.add(history.size(),nowPlaying);
	       nowPlaying = null;
	    }
	    if(!toplay.isEmpty())
	       nowPlaying = (String)toplay.remove(0);
	 }

	 nextPrevTerm();
	 return null;
      }
      
      private void nextPrevTerm()
      {
	 if(aplayer != null)
	 {
	    aplayer.close();
	    aplayer = null;
	 }
      }

      // returns null on sucess, error message otherwise
      public String setUpPreviousSong(int n)
      {
	 for(int i = 0 ; i < n ; i++)
	 {
	    if(nowPlaying != null)
	    {
	       toplay.add(0,nowPlaying);
	       nowPlaying = null;
	    }
	    
	    if(!history.isEmpty())
	       nowPlaying = (String)history.remove(history.size()-1);
	 }

	 if(nowPlaying == null)
	    setUpNextSong();
	 else
	    nextPrevTerm();

	 return null;
      }

      public String setUpPreviousSong()
      {
	 return setUpPreviousSong(1);
      }

      public void startPlayingSong()
      {
/*	 if(nowPlaying == null && !toplay.isEmpty())
	    nowPlaying = (String)toplay.remove(0);
*/

	 if(nowPlaying != null)
	 {
	    try
	    {
	       aplayer = new TweakedPlayer(new FileInputStream(nowPlaying),this);
	       aplayer.play();
	       deamon.queueUpdated();
	    }
	    catch(FileNotFoundException fnfe)
	    {
	       System.err.println("Someone slipped me a nonexistant file.  For shame.");
	    }
	    catch(javazoom.jl.decoder.JavaLayerException jle)
	    {
	       System.err.println("The media player doesn't seem to like your file");
	    }
	 }
      }

      public String pause()
      {
	 if(aplayer != null)
	 {
	    state = PAUSED;
	    aplayer.pause();
	    return null;
	 }
	 return "Player is not available";
      }

      public String unpause()
      {
	 if(aplayer != null)
	 {
	    state = PLAYING;
	    aplayer.resume();
	    return null;
	 }
	 return "Player is not available";
      }

      public String getNowPlaying()
      {
	 if(nowPlaying == null)
	    return "Nothing";

	 if(nowPlaying.startsWith(deamon.musicroot))
	    return nowPlaying.substring(deamon.musicroot.length(),nowPlaying.length());
	 else
	 {
	    if (deamon.debug > 1)
	       System.out.println("A file not in music root snuck in: " + nowPlaying);
	    return nowPlaying;
	 }
      }

      public String previousSong()
      {
	 return setUpPreviousSong();
      }
      
      public String previousSongN(int n)
      {
	 return setUpPreviousSong(n);
      }

      public String nextSong()
      {
	 String n = setUpNextSong();
	 String p = setUpPreviousSong();
	 
	 if(n == null)
	    return p;
	 return n;	       
      }

      public String nextSongN(int n)
      {
	 return setUpNextSong(n);
      }


      public String stopp()
      {
	 if(stopped())
	    return "0 Already stopped";
	 state = STOPPED;

	 if(aplayer != null)
         {
            aplayer.close();
            aplayer = null;
         }

	 return "1 Playing stopped";
      }

      public String startt()
      {
	 if(!stopped())
	    return "0 Already playing";
	 state = PLAYING;
	 return "1 Playing resumed";
      }

      public String getStatus()
      {
	 return (nowPlaying == null ? "No File" : 
		 (stopped() ? "Stopped" : 
		  ((paused()? "Paused : " : "Playing : ") + nowPlaying)));
      }
}
