import java.util.*;
import java.net.*;
import java.io.*;

class Server extends Thread
{
      ServerSocket listener = null;
      PlayMusicD deamon = null;
      String allow = null;
      String deny = null;
      boolean done = false;

      Vector connections = new Vector();

      public Server(int portNum, String allow, String deny, PlayMusicD deamon)
      {
	 this.deamon = deamon;
	 this.allow = allow;
	 this.deny = deny;

	 try
	 {
	    listener = new ServerSocket(portNum);
	 }
	 catch (IOException ioe)
	 {
	    Utility.die("Can't listen on port " + portNum);
	 }
	 if(deamon.debug > 1)
	    System.out.println("Listening for connections...");
      }

      public Collection getConnections()
      {
	 return connections;
      }

      public void removeConnection(ConnectionHandler ch)
      {
	 ch.tellDead();
	 connections.remove(ch);
	 if(deamon.debug > 1)
	    System.out.println("Removing connection");
      }

      public void broadcast(String s)
      {
	 for (int i = 0 ; i < connections.size() ; i++)
	    ((ConnectionHandler)connections.get(i)).notify(s);
      }

      public void run()
      {
	 while (!done)
	 {

	    Utility.sleep(1000);

	    Socket tsock = null;
	    try
	    {
	       // wait for someone to try to connect
	       tsock = listener.accept();
	    }
	    catch (IOException ioe)
	    {
	       Utility.die("Server can't accept connection.  This is bad.");
	    }
	    	    
	    if(deamon.debug > 1)
	       System.out.println("Got connection from " + tsock.getInetAddress());
	    
	    ConnectionHandler ch = new ConnectionHandler(deamon,tsock,allow,deny);
	    ch.start();
	    connections.add(ch);
	 }
      }
}